ADD_EXECUTABLE(${PROJECT_NAME} ${SOURCE_FILES})

FIND_PACKAGE(SDL2 REQUIRED)
Message("")
Message(STATUS "FINDING SDL2")
IF (${SDL2_FOUND})
    Message(STATUS "SDL2_FOUND: " ${SDL2_FOUND})
    Message(STATUS "SDL2_INCLUDE_DIR:" ${SDL2_INCLUDE_DIR})
    Message(STATUS "SDL2_LIBRARY: " ${SDL2_LIBRARY})
ELSE ()
    Message(STATUS "SDL2_FOUND: " ${SDL2_FOUND})
    Message(FATAL_ERROR "SDL2 NOT FOUND")
ENDIF ()

FIND_PACKAGE(SDL2_IMAGE)
Message("")
Message(STATUS "FINDING SDL2_IMAGE")
Message(STATUS "SDL2_IMAGE_FOUND: " ${SDL2_IMAGE_FOUND})
IF (${SDL2_IMAGE_FOUND})
    Message(STATUS "SDL2_IMAGE_INCLUDE_DIR: " ${SDL2_IMAGE_INCLUDE_DIR})
    Message(STATUS "SDL2_IMAGE_LIBRARY: " ${SDL2_IMAGE_LIBRARY})
ELSE ()
    Message(FATAL_ERROR "SDL2_IMAGE NOT FOUND")
ENDIF ()

FIND_PACKAGE(SDL2TTF)
Message("")
Message(STATUS "FINDING SDL2TTF")
Message(STATUS "SDL2TTF_FOUND: " ${SDL2TTF_FOUND})
IF (${SDL2TTF_FOUND})
    Message(STATUS "SDL2TTF_INCLUDE_DIR: " ${SDL2TTF_INCLUDE_DIR})
    Message(STATUS "SDL2TTF_LIBRARY: " ${SDL2TTF_LIBRARY})
ELSE ()
    Message(FATAL_ERROR "SDL2TTF NOT FOUND")
ENDIF ()
Message("")

FIND_PACKAGE(SDL2Mixer)

Message(STATUS "FINDING SDL2Mixer")
Message(STATUS "SDL2Mixer_FOUND: " ${SDL2Mixer_FOUND})

Message("")

file(COPY asset DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

# ------- End Finds ------ #

# ------- Inc & Link ---- #

INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIR} ${SDL2TTF_INCLUDE_DIR} ${SDL2_IMAGE_INCLUDE_DIR} ${SDL2Mixer_INCLUDE_DIR})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${SDL2_LIBRARY} ${SDL2TTF_LIBRARY} ${SDL2_IMAGE_LIBRARY} ${SDL2Mixer_LIBRARY})

# ------- End ----------- #

include(CheckPIESupported)
check_pie_supported()

set_property(TARGET ${PROJECT_NAME} PROPERTY POSITION_INDEPENDENT_CODE TRUE)